SystemOrganization addCategory: #'Xtreams-HttpTests'!

TestCase subclass: #XTChunkingReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:00'!
testGrowing
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 53 13 10 100 101 102 103 104 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream read: 8.
	self assert: actual = #[97 98 99 100 101 102 103 104]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:30'!
testHexLengths
	
	| actual stream |
	stream :=  #[70 13 10 97 98 99 100 101 102 103 104 105 
				  106 107 108 109 110 111 13 10 48 13 10 13 10] reading chunking.
	actual := stream rest.
	self assert: actual = #[97 98 99 100 101 102 103 104 105 106 107 108 109 110 111]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:10'!
testPartialChunk
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	stream read: 2.
	actual := stream read: 3.
	self assert: actual = #[99 100 101]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:09'!
testRest
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream rest.
	self assert: actual = #[97 98 99 100 101]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:02'!
testShrinking
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream read: 5.
	self assert: actual = #[97 98 99 100 101]! !

TestCase subclass: #XTChunkingWriteStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 18:42'!
chunk: aString
	| text |
	text := String new writing
		write: (aString size printStringBase: 16);
		cr;
		lf;
		write: aString;
		cr;
		lf;
		conclusion.
	^ text asByteArray! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 18:48'!
last: aString
	^ (self chunk: aString) , (self chunk: '')! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 21:22'!
testClose
	| compare stream |
	compare := (self last: 'abcdef') reading.
	stream := [ :byte | self assert: byte = compare get ] writing chunking.
	stream
		write: 'abc' asByteArray;
		write: 'def' asByteArray;
		close.
	self should: [ compare get ] raise: Incomplete! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 22:15'!
testHexLengths
	| compare stream |
	compare := (self chunk: 'abcdefghijklmno') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abcdefghijklmno';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 09:27'!
testMultipleWrites
	| compare stream |
	compare := (self chunk: 'abcdef') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abc';
		write: 'def';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:37'!
testOverflow
	| compare stream |
	compare := (self chunk: 'abcdef') reading.
	stream := [:byte | self assert: byte = compare get] writing chunking.
	stream bufferSize: 6.
	stream 
		write: 'abc';
		write: 'defghi'.
	self should: [compare get] raise: Incomplete.
	compare := (self chunk: 'ghi') reading.
	stream flush.
	self should: [compare get] raise: Incomplete.! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 01:07'!
testShortChunk
	| compare stream |
	compare := (self chunk: 'abc') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abc';
		flush.
	self should: [compare get] raise: Incomplete.
	! !
